///////////////////////////////////////////////////////
Ball ball1;
Ball ball2;

void setup() {
size(400,400);
smooth();
ball1 = new Ball(32);
ball2 = new Ball(32);
}
void draw() {
background(255);
ball1.move();
ball2.setLocation(mouseX,mouseY);
if (ball1.intersect(ball2)) {
}
ball1.display();
ball2.display();
}
class Ball {
float r; // radius
float x,y;
float xspeed,yspeed;
color c = color(100,50);
// Constructor
Ball(float tempR) {
r = tempR;
x = random(width);
y = random(height);
xspeed = random( -5,5);
yspeed = random( -5,5);
}
void move() {
x += xspeed; // Increment x
y += yspeed; // Increment y
// Check horizontal edges
if (x > width-r || x < 0) {
xspeed *= -1;
}
// Check vertical edges
if (y > height-r || y < 0) {
yspeed *= -1;
}
}

void setLocation(float tempX, float tempY) {
x = tempX;
y = tempY;
}
// Draw the ball
void display() {
stroke(0);
fill(c);
ellipse(x,y,r*2,r*2);
c = color(100,50);
}
boolean intersect(Ball b) {
float distance = dist(x,y,b.x,b.y); 
if (distance < r + b.r)
{ 
xspeed *= -1;
yspeed *= -1;
return true;
} else {
return false;
}
}
}

